%if 0%{?el7}
%define dist .el7
%endif

%{!?_unitdir: %global _unitdir /lib/systemd/system}
%{!?_tmpfilesdir:%global _tmpfilesdir %{_prefix}/lib/tmpfiles.d}

Name:           c-icap
Version:        0.4.4
Release:        1%{?dist}
Summary:        c-icap is an implementation of an ICAP server.

Packager:       momo-i <webmaster@momo-i.org>
Vendor:         momo-i, http://www.momo-i.org/

Group:          System Environment/Daemons
License:        LGPLv2.1
URL:            http://c-icap.sourceforge.net/
Source0:        http://sourceforge.net/projects/c-icap/files/c-icap/0.4.x/c_icap-%{version}.tar.gz
Source1:        %{name}-tmpfiles.conf
Source2:        %{name}.service
Source3:        %{name}.init
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

%if 0%{?fedora} || 0%{?rhel} >= 6
BuildRequires:  perl-devel
%else
BuildRequires:  perl
%endif
BuildRequires:	openldap-devel
BuildRequires:	zlib-devel
BuildRequires:  bzip2-devel
BuildRequires:  libmemcached-devel
BuildRequires:  pcre-devel
%if 0%{?fedora}
BuildRequires:	libdb-devel
%endif
%if 0%{?rhel}
BuildRequires:  db4-devel
%endif
BuildRequires:  gdbm-devel

%if 0%{?fedora} >= 17 || 0%{?rhel} >= 7
Requires(post): systemd-units
Requires(preun): systemd-units
Requires(postun): systemd-units
%else
Requires(post): /sbin/chkconfig
Requires(preun): /sbin/chkconfig
Requires(preun): /sbin/chkconfig
%endif

%description
c-icap is an implementation of an ICAP server. It can be used with HTTP proxies that support the ICAP protocol to implement content adaptation and filtering services. 

%package devel
Summary:        Libraries for c-icap.
Group:          Development/Libraries
Requires:       %{name} = %{version}-%{release}

%description devel
Libraries for %{name}.

%prep
%setup -q -n c_icap-%{version}

%build
%configure \
	--sysconfdir=%{_sysconfdir}/c-icap \
	--enable-shared \
	--enable-large-files \
	--enable-ipv6 \
	--enable-sysvipc \
	--with-perl \
	--with-zlib \
	--with-bzlib \
	--with-bdb \
	--with-ldap \
	--with-memcached \
	--with-pcre

make %{?_smp_mflags}

sed -i -e 's|/var/tmp|/tmp|g' \
	-e 's|/usr/lib/|%{_libdir}/|g' \
	-e 's|/usr/etc/c-icap.magic|/etc/c-icap/c-icap.magic|g' \
	-e 's|/usr/local/c-icap/etc/|/etc/c-icap/|g' \
	-e 's|/usr/var/log/|/var/log/c-icap/|g' \
	c-icap.conf.in

%if 0%{?fedora} >= 17 || 0%{?rhel} >= 7
sed -i -e 's|/var/run/|/run/|g' \
	c-icap.conf.in
%endif

%install
rm -rf $RPM_BUILD_ROOT
make install DESTDIR=$RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT%{_localstatedir}/run/c-icap
mkdir -p $RPM_BUILD_ROOT%{_localstatedir}/log/c-icap
find $RPM_BUILD_ROOT -name '*.la' | xargs rm

%if 0%{?fedora} >= 17 || 0%{?rhel} >= 7
	sed -e 's|@SYSCONFDIR@|%{_sysconfdir}|g' \
		-e 's|@BINDIR@|%{_bindir}|g' %{SOURCE2} \
		> c-icap.service
	install -D -m644 %{SOURCE1} $RPM_BUILD_ROOT%{_tmpfilesdir}/c-icap.conf
	install -D -m644 c-icap.service $RPM_BUILD_ROOT%{_unitdir}/c-icap.service
%else
	sed -e 's|@SYSCONFDIR@|%{_sysconfdir}|g' \
		-e 's|@BINDIR@|%{_bindir}|g' \
		-e 's|@RUNDIR@|%{_var}/run|g' %{SOURCE3} > c-icap.init
	install -D -m755 c-icap.init $RPM_BUILD_ROOT%{_sysconfdir}/rc.d/init.d/c-icap
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%post
%if 0%{?fedora} >= 17 || 0%{?rhel} >= 7
%systemd_post c-icap.service
%else
/sbin/chkconfig --add c-icap
/sbin/ldconfig
%endif

%preun
%if 0%{?fedora} >= 17 || 0%{?rhel} >= 7
%systemd_preun c-icap.service
%else
if [ $1 -eq 0 ]; then
	/sbin/service c-icap stop > /dev/null 2>&1
	/sbin/chkconfig --del c-icap
fi
%endif

%postun
%if 0%{?fedora} >= 17 || 0%{?rhel} >= 7
%systemd_postun_with_restart c-icap.service
%else
/sbin/ldconfig
%endif

%files
%defattr(-,root,root,-)
%doc AUTHORS ChangeLog INSTALL NEWS README RECONF TODO contrib/
%{!?_licensedir:%global license %%doc}
%license COPYING
%attr(0644,root,root) %config(noreplace) %{_sysconfdir}/c-icap/c-icap.conf
%attr(0644,root,root) %config(noreplace) %{_sysconfdir}/c-icap/c-icap.magic
%attr(0644,root,root) %{_sysconfdir}/c-icap/c-icap.conf.default
%attr(0644,root,root) %{_sysconfdir}/c-icap/c-icap.magic.default
%{_bindir}/c-icap
%{_bindir}/c-icap-client
%{_bindir}/c-icap-mkbdb
%{_bindir}/c-icap-stretch
%{_libdir}/libicapapi.so.*
%{_libdir}/c_icap/*.so
%{_mandir}/man8/c-icap*.8.gz
%if 0%{?fedora} >= 17 || 0%{?rhel} >= 7
%{_tmpfilesdir}/c-icap.conf
%{_unitdir}/c-icap.service
%else
%{_sysconfdir}/rc.d/init.d/c-icap
%endif
%dir %{_localstatedir}/run/c-icap
%dir %{_localstatedir}/log/c-icap

%files devel
%{_bindir}/c-icap-config
%{_bindir}/c-icap-libicapapi-config
%{_includedir}/c_icap/*.h
%{_libdir}/libicapapi.so

%changelog
* Sat Oct 01 2016 momo-i <webmaster@momo-i.org> - 0.4.4-1
- Update to 0.4.4

* Mon Sep 28 2015 momo-i <webmaster@momo-i.org> - 0.4.2-1
- Update to 0.4.2

* Thu Sep 03 2015 momo-i <webmaster@momo-i.org> - 0.3.5-8
- Update dist for centos7

* Mon Aug 10 2015 momo-i <webmaster@momo-i.org> - 0.3.5-7
- Rebuilt for fc23

* Tue Dec  2 2014 momo-i <webmaster@momo-i.org> - 0.3.5-6
- Use unitdir and tmpfilesdir

* Tue Nov 11 2014 momo-i <webmaster@momo-i.org> - 0.3.5-4
- Update to 0.3.5
- Change license dir

* Fri Sep  5 2014 momo-i <webmaster@momo-i.org> - 0.3.4-4
- Update to 0.3.4

* Tue Apr 22 2014 momo-i <webmaster@momo-i.org> - 0.3.3-4
- Update to 0.3.3

* Wed Jan 15 2014 momo-i <webmaster@momo-i.org> - 0.3.2-4
- Update to 0.3.2

* Mon Nov 25 2013 momo-i <webmaster@momo-i.org> - 0.3.1-4
- update %files

* Mon Nov 18 2013 momo-i <webmaster@momo-i.org> - 0.3.1-3
- Update c-icap.service

* Mon Nov 18 2013 momo-i <webmaster@momo-i.org> - 0.3.1-2
- mkdir /var/run/c-icap and /var/log/c-icap

* Thu Nov 14 2013 momo-i <webmaster@momo-i.org> - 0.3.1-1
- Update to 0.3.1

* Wed Oct  9 2013 momo-i <webmaster@momo-i.org> - 0.2.6-2
- Add tmpfiles.d

* Wed Oct  9 2013 momo-i <webmaster@momo-i.org> - 0.2.6-1
- Initial rpm release.
